/*
 * main.c
 *
 * Created: 11/8/2023 11:04:14 AM
 *  Author: controllerstech
 */ 

#define F_CPU 5000000
#include <xc.h>
#include <util/delay.h>
#include <avr/interrupt.h>

void clkInit(void)
{
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLA, 0);  // Internal 20MHz OSC, CLKOUT=0
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLB, 0x03);  // PEN=1, DIV=4
	while ((CLKCTRL.MCLKSTATUS & (1<<4)) == 0);  // wait for the osc to stabilize.
}

void uartInit ()
{
	USART0.CTRLA = (1<<7);  // Enable RXCIE Interrupt
	USART0.CTRLB = (1<<7)|(1<<6);  // Enable RX and TX
	USART0.CTRLC = 0x03;  // Asynch mode, no parity, 1 stop bit, 8 data bits
	USART0.BAUD = 174;  // PER_CLK = 5MHz, Baud = 115200
	USART0.STATUS |= 1<<6;  // Clear TXCIF flag
	
	PORTB.DIR = 0x04;  // PB2->OUT, PB3->IN
}

void uartSendByte (char byte)
{
	USART0.TXDATAL = byte;
	while (((USART0.STATUS)&(1<<6)) == 0);  // wait for the TXCIF bit to set
	USART0.STATUS |= (1<<6);  // clear the TXCIF flag
}

void uartSendStr (char *str)
{
	while (*str)
	{
		uartSendByte(*str++);
	}
}

int indx = 0;
char RxData[10];
char datatosend[] = "Hello World from AVR\r\n";

int main(void)
{
	clkInit();
	uartInit();
	sei();
	while(1)
	{
//		uartSendStr(datatosend);
//		_delay_ms(1000);
	}
}

ISR (USART0_RXC_vect)
{
	RxData[indx++] = USART0.RXDATAL;  // store data from RX Register to the buffer
	if (indx > 9) indx = 0;
}